;;; $Id: careless.scm,v 3.10 1994/09/12 17:31:10 queinnec Exp $ 
;;; Copyright (c) 1990-93 by Christian Queinnec. All rights reserved.

;;;                ***********************************************
;;;                    Small, Efficient and Innovative Class System
;;;                                    Meroon 
;;;                              Christian Queinnec  
;;;                   \'Ecole Polytechnique & INRIA--Rocquencourt
;;;                ************************************************

;;; These functions are needed for the bootstrap. CAUTION: this file
;;; must be regenerated if the structure of the primitive classes
;;; change since offsets are hardwired here. These accessors are used
;;; in safe contexts and are necessary for speed (in absence of a
;;; type-recovery analysis in define-method forms).

(define-inline (careless-Class-name class) 
  (instance-ref class 0) )
(define-inline (careless-initialize-Class-name class name) 
  (instance-set! class 0 name) )
;(define-inline (careless-Class-number class)
;  (instance-ref class 1) )
(define-inline (careless-set-Class-number! class cn)
  (instance-set! class 1 cn) )
(define-inline (careless-Class-fields class)
  (instance-ref class 2) )
(define-inline (careless-initialize-Class-fields class fields)
  (instance-set! class 2 fields) )
(define-inline (careless-Class-super-number class)
  (instance-ref class 3) )
(define-inline (careless-set-Class-super-number! class cn)
  (instance-set! class 3 cn) )
(define-inline (careless-initialize-Class-super-number class scn)
  (instance-set! class 3 scn) )
(define-inline (careless-Class-subclass-numbers class)
  (instance-ref class 4) )
;(define-inline (careless-Class-allocator class)
;  (instance-ref class 5) )
(define-inline (careless-initialize-Class-allocator class f)
  (instance-set! class 5 f) )
(define-inline (careless-initialize-Class-immutable? class bool)
  (instance-set! class 6 bool) )
(define-inline (careless-Class-min-son class)
  (instance-ref class 7) )
(define-inline (careless-set-Class-min-son! class cn)
  (instance-set! class 7 cn) )
(define-inline (careless-Class-max-son class)
  (instance-ref class 8) )
(define-inline (careless-set-Class-max-son! class cn)
  (instance-set! class 8 cn) )
(define-inline (careless-Class-super-length class)
  (instance-ref class 9) )
(define-inline (careless-Class-super class index)
  (if (and (>= index 0) (< index (careless-Class-super-length class)))
      (instance-ref class (+ 9 1 index))
      (report-bad-index 'super class index) ) )
(define-inline (careless-set-Class-super! class index cn)
  (if (and (>= index 0) (< index (careless-Class-super-length class)))
      (instance-set! class (+ 9 1 index) cn)
      (report-bad-index 'super class index) ) )

(define-inline (careless-Field-immutable? field)
  (instance-ref field 0) )
(define-inline (careless-initialize-Field-immutable? field bool)
  (instance-set! field 0 bool) )
(define-inline (careless-Field-name field)
  (instance-ref field 1) )
(define-inline (careless-initialize-Field-name field name)
  (instance-set! field 1 name) )
(define-inline (careless-Field-class-number field)
  (instance-ref field 2) )
(define-inline (careless-initialize-Field-class-number field cn)
  (instance-set! field 2 cn) )
(define-inline (careless-set-Field-class-number! field cn)
  (instance-set! field 2 cn) )
(define-inline (careless-Field-initialized? field)
  (instance-ref field 3) )
(define-inline (careless-initialize-Field-initialized? field bool)
  (instance-set! field 3 bool) )
(define-inline (careless-Field-initializer field)
  (instance-ref field 4) )
(define-inline (careless-initialize-Field-initializer field fun)
  (instance-set! field 4 fun) )
(define-inline (careless-Field-path-length field)
  (instance-ref field 5) )
(define-inline (careless-Field-path field index)
  (instance-ref field (+ 5 1 index)) )

;(define-inline (careless-Generic-behavior g)
;  (instance-ref g 0) )
(define-inline (careless-Generic-name g)
  (instance-ref g 1) )
(define-inline (careless-set-Generic-name! g name)
  (instance-set! g 1 name) )
(define-inline (careless-Generic-default g)
  (instance-ref g 2) )
(define-inline (careless-initialize-Generic-default g d)
  (instance-set! g 2 d) )
(define-inline (careless-initialize-Generic-dispatcher g d)
  (instance-set! g 4 d) )
(define-inline (careless-set-Generic-dispatcher! g d)
  (instance-set! g 4 d) )
(define-inline (careless-Generic-top-classes g)
  (instance-ref g 5) )
(define-inline (careless-initialize-Generic-top-classes g cs)
  (instance-set! g 5 cs) )

(define-inline (careless-Dispatcher-method-finder d)
  (instance-ref d 0) )
(define-inline (careless-initialize-Dispatcher-method-finder d v)
  (instance-set! d 0 v) )

(define-inline (careless-Immediate-Dispatcher-method d)
  (instance-ref d 1) )

(define-inline (careless-Global-Dispatcher-method-length d)
  (instance-ref d 1) )
(define-inline (careless-Global-Dispatcher-method d i)
  (instance-ref d (+ 2 i)) )
(define-inline (careless-set-Global-Dispatcher-method! d i m)
  (instance-set! d (+ 2 i) m) )

(define-inline (careless-Indexed-Dispatcher-class-number d)
  (instance-ref d 1) )
(define-inline (careless-set-Indexed-Dispatcher-class-number! d cn)
  (instance-set! d 1 cn) )
(define-inline (careless-Indexed-Dispatcher-no d)
  (instance-ref d 2) )
(define-inline (careless-set-Indexed-Dispatcher-no! d v)
  (instance-set! d 2 v) )
(define-inline (careless-Indexed-Dispatcher-min d)
  (instance-ref d 3) )
(define-inline (careless-set-Indexed-Dispatcher-min! d cn)
  (instance-set! d 3 cn) )
(define-inline (careless-Indexed-Dispatcher-max d)
  (instance-ref d 4) )
(define-inline (careless-set-Indexed-Dispatcher-max! d v)
  (instance-set! d 4 v) )
(define-inline (careless-Indexed-Dispatcher-method-length d)
  (instance-ref d 5) )
(define-inline (careless-Indexed-Dispatcher-method d i)
  (instance-ref d (+ 6 i)) )
(define-inline (careless-set-Indexed-Dispatcher-method! d i v)
  (instance-set! d (+ 6 i) v) )

(define-inline (careless-Subclass-Dispatcher-class-number d)
  (instance-ref d 1) )
(define-inline (careless-set-Subclass-Dispatcher-class-number! d cn)
  (instance-set! d 1 cn) )
(define-inline (careless-Subclass-Dispatcher-no d)
  (instance-ref d 2) )
(define-inline (careless-set-Subclass-Dispatcher-no! d v)
  (instance-set! d 2 v) )
(define-inline (careless-Subclass-Dispatcher-min d)
  (instance-ref d 3) )
(define-inline (careless-set-Subclass-Dispatcher-min! d v)
  (instance-set! d 3 v) )
(define-inline (careless-Subclass-Dispatcher-max d)
  (instance-ref d 4) )
(define-inline (careless-set-Subclass-Dispatcher-max! d v)
  (instance-set! d 4 v) )
(define-inline (careless-Subclass-Dispatcher-yes d)
  (instance-ref d 5) )
(define-inline (careless-set-Subclass-Dispatcher-yes! d v)
  (instance-set! d 5 v) )

(define-inline (careless-initialize-Linear-Dispatcher-method d m)
  (instance-set! d 2 m) )

;;; end of careless.scm
