;;; $Id: genes2.scm,v 3.5 1995/06/14 18:56:08 queinnec Exp $ 
;;; Copyright (c) 1990-93 by Christian Queinnec. All rights reserved.

;;;                ***********************************************
;;;                    Small, Efficient and Innovative Class System
;;;                                    Meroon 
;;;                              Christian Queinnec  
;;;                   \'Ecole Polytechnique & INRIA--Rocquencourt
;;;                ************************************************

;;; This file defines the end of the initial net of classes, generics
;;; and methods that are needed by Meroon to run. It is a delicate
;;; piece of bootstrap.

;;;========================================================= Field
;;; The initializer field is now mutable.
(define Field-class
  (instance
   original-Class-class-number          ; internal index 
   'Field                               ; name
   original-Field-class-number          ; number
   (list                                ; fields
    (create-Mono-Field #t 'immutable?   original-Field-class-number 0)
    (create-Mono-Field #t 'name         original-Field-class-number 1)
    (create-Mono-Field #f 'class-number original-Field-class-number 2)
    (create-Mono-Field #t 'initialized? original-Field-class-number 3)
    (create-Mono-Field #f 'initializer  original-Field-class-number 4)
    (create-Poly-Field #t 'path         original-Field-class-number 5) )
   original-Object-class-number         ; super-number
   (list                                ; subclasses
    original-Mono-Field-class-number
    original-Poly-Field-class-number )
   meroon-uninitialized                 ; allocator
   #f                                   ; immutable?
   original-Field-class-number          ; min-son
   original-Poly-Field-class-number     ; max-son
   2
   original-Object-class-number         ; super[0]
   original-Field-class-number          ; super[1]
   ) )

;;;========================================================= Mono-Field
(define Mono-Field-class
  (instance
   original-Class-class-number          ; internal index 
   'Mono-Field                          ; name
   original-Mono-Field-class-number     ; number
   (simple-append-fields                ; fields
    (careless-Class-fields Field-class)
    (list) )
   original-Field-class-number          ; super-number
   (list)                               ; subclasses
   meroon-uninitialized                 ; allocator
   #f                                   ; immutable?
   original-Mono-Field-class-number     ; min-son
   original-Mono-Field-class-number     ; max-son
   3
   original-Object-class-number         ; super[0]
   original-Field-class-number          ; super[1]
   original-Mono-Field-class-number     ; super[2]
   ) )

;;;========================================================= Poly-Field
(define Poly-Field-class
  (instance
   original-Class-class-number          ; internal index 
   'Poly-Field                          ; name
   original-Poly-Field-class-number     ; number
   (simple-append-fields                ; fields
    (careless-Class-fields Field-class)
    (list) )
   original-Field-class-number          ; super-number
   (list)                               ; subclasses
   meroon-uninitialized                 ; allocator
   #f                                   ; immutable?
   original-Poly-Field-class-number     ; min-son
   original-Poly-Field-class-number     ; max-son
   3
   original-Object-class-number         ; super[0]
   original-Field-class-number          ; super[1]
   original-Poly-Field-class-number     ; super[2]
   ) )

;;;========================================================= Dispatcher
(define Dispatcher-class
  (instance
   original-Class-class-number          ; internal index 
   'Dispatcher                          ; name
   original-Dispatcher-class-number     ; number
   (list                                ; fields
    (create-Mono-Field #t 'method-finder original-Dispatcher-class-number 0) )
   original-Object-class-number         ; super-number
   (list                                ; subclasses
    original-Immediate-Dispatcher-class-number
    original-Subclass-Dispatcher-class-number
    original-Indexed-Dispatcher-class-number
    original-Linear-Dispatcher-class-number
    original-Global-Dispatcher-class-number
    original-Tracing-Dispatcher-class-number
    )
   meroon-uninitialized                 ; allocator
   #t                                   ; immutable?
   original-Dispatcher-class-number     ; min-son
   original-Tracing-Dispatcher-class-number ; max-son
   2
   original-Object-class-number         ; super[0]
   original-Dispatcher-class-number     ; super[1]
   ) )

;;;======================================================= Immediate-Dispatcher
(define Immediate-Dispatcher-class
  (instance
   original-Class-class-number          ; internal index 
   'Immediate-Dispatcher                ; name
   original-Immediate-Dispatcher-class-number ; number
   (simple-append-fields                ; fields
    (careless-Class-fields Dispatcher-class)
    (list
     (create-Mono-Field #t 'method  
                        original-Immediate-Dispatcher-class-number 1 ) ) )
   original-Dispatcher-class-number     ; super-number
   (list)                               ; subclasses
   meroon-uninitialized                 ; allocator
   #t                                   ; immutable?
   original-Immediate-Dispatcher-class-number ; min-son
   original-Immediate-Dispatcher-class-number ; max-son
   3
   original-Object-class-number         ; super[0]
   original-Dispatcher-class-number     ; super[1]
   original-Immediate-Dispatcher-class-number ; super[2]
   ) )

;;;======================================================= Subclass-Dispatcher
(define Subclass-Dispatcher-class
  (instance
   original-Class-class-number          ; internal index 
   'Subclass-Dispatcher                 ; name
   original-Subclass-Dispatcher-class-number ; number
   (simple-append-fields                ; fields
    (careless-Class-fields Dispatcher-class)
    (list
     (create-Mono-Field #f 'class-number 
                        original-Subclass-Dispatcher-class-number 1)
     (create-Mono-Field #f 'no
                        original-Subclass-Dispatcher-class-number 2)
     (create-Mono-Field #f 'min
                        original-Subclass-Dispatcher-class-number 3)
     (create-Mono-Field #f 'max
                        original-Subclass-Dispatcher-class-number 4)
     (create-Mono-Field #f 'yes
                        original-Subclass-Dispatcher-class-number 5) ) )
   original-Dispatcher-class-number     ; super-number
   (list)                               ; subclasses
   meroon-uninitialized                 ; allocator
   #t                                   ; immutable?
   original-Subclass-Dispatcher-class-number ; min-son
   original-Subclass-Dispatcher-class-number ; max-son
   3
   original-Object-class-number         ; super[0]
   original-Dispatcher-class-number     ; super[1]
   original-Subclass-Dispatcher-class-number ; super[2]
   ) )

;;;======================================================= Indexed-Dispatcher
(define Indexed-Dispatcher-class
  (instance
   original-Class-class-number          ; internal index 
   'Indexed-Dispatcher                  ; name
   original-Indexed-Dispatcher-class-number ; number
   (simple-append-fields                ; fields
     (careless-Class-fields Dispatcher-class)
    (list
     (create-Mono-Field #f 'class-number
                        original-Indexed-Dispatcher-class-number 1)
     (create-Mono-Field #f 'no
                        original-Indexed-Dispatcher-class-number 2)
     (create-Mono-Field #f 'min
                        original-Indexed-Dispatcher-class-number 3)
     (create-Mono-Field #f 'max
                        original-Indexed-Dispatcher-class-number 4)
     (create-Poly-Field #f 'method
                        original-Indexed-Dispatcher-class-number 5) ) )
   original-Dispatcher-class-number     ; super-number
   (list)                               ; subclasses
   meroon-uninitialized                 ; allocator
   #t                                   ; immutable?
   original-Indexed-Dispatcher-class-number ; min-son
   original-Indexed-Dispatcher-class-number ; max-son
   3
   original-Object-class-number         ; super[0]
   original-Dispatcher-class-number     ; super[1]
   original-Indexed-Dispatcher-class-number ; super[2]
   ) )

;;;======================================================= Linear-Dispatcher
(define Linear-Dispatcher-class
  (instance
   original-Class-class-number          ; internal index 
   'Linear-Dispatcher                   ; name
   original-Linear-Dispatcher-class-number ; number
   (simple-append-fields               ; fields
    (careless-Class-fields Dispatcher-class)
    (list
     (create-Mono-Field #f 'no
                        original-Linear-Dispatcher-class-number 1)
     (create-Mono-Field #f 'method
                        original-Linear-Dispatcher-class-number 2)
     (create-Mono-Field #f 'signature
                        original-Linear-Dispatcher-class-number 3) ) )
   original-Dispatcher-class-number     ; super-number
   (list)                               ; subclasses
   meroon-uninitialized                 ; allocator
   #t                                   ; immutable?
   original-Linear-Dispatcher-class-number ; min-son
   original-Linear-Dispatcher-class-number ; max-son
   3
   original-Object-class-number         ; super[0]
   original-Dispatcher-class-number     ; super[1]
   original-Linear-Dispatcher-class-number ; super[2]
   ) )

;;;======================================================= Global-Dispatcher
(define Global-Dispatcher-class
  (instance
   original-Class-class-number          ; internal index 
   'Global-Dispatcher                   ; name
   original-Global-Dispatcher-class-number ; number
   (simple-append-fields                ; fields
    (careless-Class-fields Dispatcher-class)
    (list
     (create-Poly-Field #f 'method
                        original-Global-Dispatcher-class-number 1) ) )
   original-Dispatcher-class-number     ; super-number
   (list)                               ; subclasses
   meroon-uninitialized                 ; allocator
   #t                                   ; immutable?
   original-Global-Dispatcher-class-number ; min-son
   original-Global-Dispatcher-class-number ; max-son
   3
   original-Object-class-number         ; super[0]
   original-Dispatcher-class-number     ; super[1]
   original-Global-Dispatcher-class-number ; super[2]
   ) )

;;;======================================================= Tracing-Dispatcher
(define Tracing-Dispatcher-class
  (instance
   original-Class-class-number          ; internal index 
   'Tracing-Dispatcher                   ; name
   original-Tracing-Dispatcher-class-number ; number
   (simple-append-fields                ; fields
    (careless-Class-fields Dispatcher-class)
    (list
     ;; adding methods to a traced dispatcher requires this field to be mutable.
     (create-Mono-Field #f 'dispatcher 
                        original-Tracing-Dispatcher-class-number 1 )
     (create-Mono-Field #t 'default
                        original-Tracing-Dispatcher-class-number 2 ) ) )
   original-Dispatcher-class-number     ; super-number
   (list)                               ; subclasses
   meroon-uninitialized                 ; allocator
   #t                                   ; immutable?
   original-Tracing-Dispatcher-class-number ; min-son
   original-Tracing-Dispatcher-class-number ; max-son
   3
   original-Object-class-number         ; super[0]
   original-Dispatcher-class-number     ; super[1]
   original-Tracing-Dispatcher-class-number ; super[2]
   ) )

;;;======================================================= Anomaly
(define Anomaly-class
  (instance
   original-Class-class-number          ; internal index 
   'Anomaly                             ; name
   original-Anomaly-class-number        ; number
   (list                                ; fields
    (create-Mono-Field #t 'category    original-Anomaly-class-number 0)
    (create-Mono-Field #t 'operator    original-Anomaly-class-number 1)
    (create-Mono-Field #t 'message     original-Anomaly-class-number 2)
    (create-Poly-Field #t 'hint        original-Anomaly-class-number 3)
    )
   original-Object-class-number         ; super-number
   (list                                ; subclasses
    original-Warning-class-number )
   meroon-uninitialized                 ; allocator
   #t                                   ; immutable?
   original-Anomaly-class-number        ; min-son
   original-Warning-class-number        ; max-son
   2
   original-Object-class-number         ; super[0]
   original-Anomaly-class-number        ; super[1]
   ) )

(define Warning-class
  (instance
   original-Class-class-number          ; internal index 
   'Warning                             ; name
   original-Warning-class-number        ; number
   (simple-append-fields                ; fields
    (careless-Class-fields Anomaly-class)
    (list) )
   original-Anomaly-class-number        ; super-number
   (list)                               ; subclasses
   meroon-uninitialized                 ; allocator
   #t                                   ; immutable?
   original-Warning-class-number        ; min-son
   original-Warning-class-number        ; max-son
   3
   original-Object-class-number         ; super[0]
   original-Anomaly-class-number        ; super[1]
   original-Warning-class-number        ; super[2]
   ) )

;;;oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
;;; Register all these classes in the sequence of all classes.
(for-each 
 (lambda (class) 
   (vector-set! *classes* (careless-Class-number class) class) )
 (let ((classes 
        (list 
         Object-class                   ; 0
         Class-class                    ; 1
         Handy-Class-class              ; 2
         MeroonV2-Class-class           ; 3
         Applyable-Object-class         ; 4
         Generic-class                  ; 5
         Generic-1-class                ; 6
         Generic-N-class                ; 7
         Field-class                    ; 8
         Mono-Field-class               ; 9
         Poly-Field-class               ; 10
         Dispatcher-class               ; 11
         Immediate-Dispatcher-class     ; 12
         Subclass-Dispatcher-class      ; 13
         Indexed-Dispatcher-class       ; 14
         Linear-Dispatcher-class        ; 15
         Global-Dispatcher-class        ; 16
         Tracing-Dispatcher-class       ; 17
         Anomaly-class                  ; 18
         Warning-class                  ; 19
         ) ))
   (unless (= *class-number* (length classes))
     (oo-error 'genesis "Missed some classes") )
   classes ) )

;;; This offset was needed for one implementation of is-a?
;(define Class-super-offset 
;  (compute-offset Class-class Class-super-field) )

;;; end of genes2.scm
